



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>【PHP面向对象(OOP)编程入门教程】8.构造方法__construct()与析构方法__destruct()</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">【PHP面向对象(OOP)编程入门教程】8.构造方法__construct()与析构方法__destruct()</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 12:32:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>大多数类都有一种称为构造函数的特殊方法。当创建一个对象时，它将自动调用构造函数，也就是使用new这个关键字来实例化对象的时候自动调用构造方法。构 造函数的声明与其它操作的声明一样，只是其名称必须是__construct( )。这是PHP5中的变化，以前的版本中，构造函数的名称必须与类名相同，这种在PHP5中仍然可以用，但现在以经很少有人用了，这样做的好处是可以使构 造函数独立于类名，当类名发生改变时不需要改相应的构造函数名称了。为了向下兼容，如果一个类中没有名为__construct( )的方法，PHP将搜索一个php4中的写法，与类名相同名的构造方法。</p>
<p>格式：function __construct ( [参数] ) { ... ... }</p>
<p>在一个类中只能声明一个构造方法，而是只有在每次创建对象的时候都会去调用一次构造方法，不能主动的调用这个方法，所以通常用它执行一些有用的初始化任务。比如对成属性在创建对象的时候赋初值。</p>
<pre class="prettyprint linenums">&lt;?<br />
// 创建一个人类<br />
class Person {<br />
	// 下面是人的成员属性<br />
	var $name;	// 人的名子<br />
	var $sex;	// 人的性别<br />
	var $age;	// 人的年龄

	// 定义一个构造方法参数为姓名$name、性别$sex和年龄$age<br />
	function __construct($name, $sex, $age) {<br />
		// 通过构造方法传进来的$name给成员属性$this-&gt;name赋初使值<br />
		$this-&gt;name = $name;

		// 通过构造方法传进来的$sex给成员属性$this-&gt;sex赋初使值<br />
		$this-&gt;sex = $sex;

		// 通过构造方法传进来的$age给成员属性$this-&gt;age赋初使值<br />
		$this-&gt;age = $age;<br />
	}

	// 这个人的说话方法<br />
	function say() {<br />
		echo "我的名子叫：" . $this-&gt;name . " 性别：" . $this-&gt;sex . " 我的年龄是：" . $this-&gt;age;<br />
	}<br />
}

// 通过构造方法创建3个对象$p1、p2、$p3,分别传入三个不同的实参为姓名、性别和年龄<br />
$p1 = new Person("张三","男", 20);<br />
$p2 = new Person("李四","女", 30);<br />
$p3 = new Person("王五","男", 40);

// 下面访问$p1对象中的说话方法<br />
$p1-&gt;say();

// 下面访问$p2对象中的说话方法<br />
$p2-&gt;say();

// 下面访问$p3对象中的说话方法<br />
$p3-&gt;say();<br />
?&gt;</pre>
<p>输出结果为：</p>
<blockquote><p>我的名子叫：张三 性别：男 我的年龄是：20我的名子叫：李四 性别：女 我的年龄是：30我的名子叫：王五 性别：男 我的年龄是：40</p></blockquote>
<p>如图：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/381128/201607/381128-20160717213351107-634868011.png" /></p>
<p><strong>析构函数：</strong></p>
<p>与构造函数相对的就是析构函数。析构函数是PHP5新添加的内容，在PHP4中没有析构函数。 析构函数允许在销毁一个类之前执行的一些操作或完成一些功能，比如说关闭文件， 释放结果集等，析构函数会在到某个对象的所有引用都被删除或者当对象被显式销毁时执行，也就是对象在内存中被销毁前调用析构函数。与构造函数的名称类似， 一个类的析构函数名称必须是__destruct( )。析构函数不能带有任何参数。</p>
<p>格式：function __destruct ( ) { ... ... }</p>
<pre class="prettyprint linenums">&lt;?<br />
// 创建一个人类<br />
class Person {<br />
	// 下面是人的成员属性<br />
	var $name;	// 人的名子<br />
	var $sex;	// 人的性别<br />
	var $age;	// 人的年龄

	// 定义一个构造方法参数为姓名$name、性别$sex和年龄$age<br />
	function __construct($name, $sex, $age) {<br />
		// 通过构造方法传进来的$name给成员属性$this-&gt;name赋初使值<br />
		$this-&gt;name = $name;

		// 通过构造方法传进来的$sex给成员属性$this-&gt;sex赋初使值<br />
		$this-&gt;sex = $sex;

		// 通过构造方法传进来的$age给成员属性$this-&gt;age赋初使值<br />
		$this-&gt;age = $age;<br />
	}

	// 这个人的说话方法<br />
	function say() {<br />
		echo "我的名子叫：" . $this-&gt;name . " 性别：" . $this-&gt;sex . " 我的年龄是：" . $this-&gt;age;<br />
	}

	// 这是一个析构函数,在对象销毁前调用<br />
	function __destruct() {<br />
		echo "再见" . $this-&gt;name;<br />
	}<br />
}

// 通过构造方法创建3个对象$p1、p2、$p3,分别传入三个不同的实参为姓名、性别和年龄<br />
$p1 = new Person("张三", "男", 20);<br />
$p2 = new Person("李四", "女", 30);<br />
$p3 = new Person("王五", "男", 40);

// 下面访问$p1对象中的说话方法<br />
$p1-&gt;say();

// 下面访问$p2对象中的说话方法<br />
$p2-&gt;say();

// 下面访问$p3对象中的说话方法<br />
$p3-&gt;say();<br />
?&gt;</pre>
<p>输出结果为：</p>
<blockquote><p>我的名子叫：张三 性别：男 我的年龄是：20我的名子叫：李四 性别：女 我的年龄是：30我的名子叫：王五 性别：男 我的年龄是：40<br />
再见王五<br />
再见李四<br />
再见张三</p></blockquote>
<p><strong>&nbsp;注意：</strong></p>
<p>由于类实例是以堆栈的形式放在内存中，所以最后调用 析构函数 的时候，输出顺序是按 后进先出 的原则！</p>
<p>延伸阅读：<a href="http://www.cnblogs.com/52php/p/5660041.html" rel="external nofollow noreferrer">PHP中类的继承和构造函数的继承</a></p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/39rp2m80.html">html5&plus;go&plus;websocket简单实例代码</a>
		</li>
						<li><a href="https://www.batexi.com/a/4qnjl1g8.html">Kafka基本原理</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2go738.html">MVVM架构~knockoutjs系列之一些异常的总结（永久更新）</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8ervemq.html">Java Swing快速构建窗体应用程序</a>
		</li>
						<li><a href="https://www.batexi.com/a/g8el2pxq.html">Caffe proto閱讀</a>
		</li>
						<li><a href="https://www.batexi.com/a/39rv62m8.html">关于JS闭包，作者不详（转）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn12lmk8.html">深入&period;Net字符串类型</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ok56y59.html">Codevs 1063 合并果子</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1yp328.html">好！recover-binary-search-tree（难）&amp;amp&semi; 两种好的空间O&lpar;n&rpar;解法 &amp;amp&semi; 空间O&lpar;1&rpar;解法</a>
		</li>
						<li><a href="https://www.batexi.com/a/93xgd3z9.html">python学习笔记六--用户自定义类</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmkdn49.html">CSS&mdash;&mdash;LESS</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjlme49.html">css伪类选择器详细解析及案例使用-----伪元素</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdkwd49.html">在XAMPP上建立多个域名的站点</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zorrv3q.html">Delphi 中Format的字符串格式化使用说明&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2j01wv8.html">BFC详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpvkx79.html">关于listener监听器的一些记录</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o1veelq.html">DeepLearning&period;ai-Week4-Deep Learning &amp;amp&semi; Art&colon; Neural Style Transfer</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnnpm43q.html">python学习之简介与环境安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jezvje8.html">Memcached在Windows下的配置和使用&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2xx3vx9.html">Python十六进制转码问题</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/5qxxrrdq.html">HDU 1811 Rank of Tetris（拓扑排序&plus;并查集）</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxxrpeq.html">DropZone</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyxn4g8.html">软件产品案例分析&mdash;&mdash;K米</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9jg7z49.html">iOS - CAEmitterLayer 学习笔记一</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q2v11v8.html">Ubuntu修改mysql默认编码的方法</a>
			</li>
						<li><a href="https://www.batexi.com/a/xq4wv7j9.html">深入JVM-垃圾收集器常用的GC参数</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8mz77pq.html">《Java疯狂讲义》（第3版）学习笔记 1 - 如何学习Java</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qyxzdm8.html">Java多线程&mdash;&mdash;线程范围内共享变量</a>
			</li>
						<li><a href="https://www.batexi.com/a/390l6dj9.html">Java查找算法&mdash;&mdash;二分查找</a>
			</li>
						<li><a href="https://www.batexi.com/a/5qxx74vq.html">Linux学习笔记（一）2015&period;4&period;13</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
